# File Field API

| **File field**                                                                                                                |
| ----------------------------------------------------------------------------------------------------------------------------- |
| *\<field type=”attachment” name=”string” roleId=”id” placeholder=”string” optional=”boolean” attachmentType=”enum”>\</field>* |

#### File Field attributes

* **type** — define if this field is attachment type, mandatory attribute.
* **name** — string, length from 1 up to 128 symbols, restricted symbols &, “, <, >, field name used to fill in on envelope, unique for document, mandatory attribute.
* **roleId** — id of the role who should fill field on envelope, mandatory attribute.
* **placeholder** — field placeholder displayable on template and envelope, length from 0 up to 1024 symbols, if empty on envelope will be displayed field name, optional attribute.
* **optional** — boolean, defines if field to be filled in optionally or not on envelope, if not set default value false, optional attribute.
* **attachmentType** — enum, one of the values \[all, file, document, image, archive], defines file types could be uploaded on envelope, mandatory attribute.

#### Supported document types

* All: .pdf, .doc, .docx, .xls, .xlsx, .xlsm, .xlsb, .xml, .dbf, .txt, .rtf, .csv, .xps, .eml, .msg, .emlx, .rpmsg, .crt, .pem, .der, .cer, .ppt, .pptx, .png, .jpg, .jpeg, .tiff, .tif, .zip, .7z, .rar, .asice
* File: .pdf, .doc, .docx, .xls, .xlsx, .xlsm, .xlsb, .xml, .dbf, .txt, .rtf, .csv, .xps, .eml, .msg, .emlx, .rpmsg, .crt, .pem, .der, .cer, .ppt, .pptx
* Document: .pdf
* Image: .png, .jpg, .jpeg, .tiff, .tif
* Archive: .zip, .7z, .rar, .asice


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://support.docstudio.com/docstudio-docs/docstudio-for-developers/api-documentation/template-api/template-dynamic-fields-api/file-field-api.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
